import swarm.Globals;
import swarm.Selector;
import swarm.defobj.Zone;
import swarm.activity.Activity;
import swarm.activity.ActionGroup;
import swarm.activity.ActionGroupImpl;
import swarm.activity.Schedule;
import swarm.activity.ScheduleImpl;
import swarm.objectbase.Swarm;
import swarm.objectbase.VarProbe;
import swarm.objectbase.MessageProbe;
import swarm.objectbase.EmptyProbeMapImpl;
import swarm.gui.Colormap;
import swarm.gui.ColormapImpl;
import swarm.gui.ZoomRaster;
import swarm.gui.ZoomRasterImpl;
import swarm.analysis.*;
import swarm.simtoolsgui.GUISwarm;
import swarm.simtoolsgui.GUISwarmImpl;
import swarm.space.Value2dDisplay;
import swarm.space.Value2dDisplayImpl;
import swarm.space.Object2dDisplay;
import swarm.space.Object2dDisplayImpl;
import java.util.List;
import swarm.space.Grid2d;
import swarm.space.Grid2dImpl;
import java.util.*;
import java.io.*;
public class GroupObserver extends GUISwarmImpl
{	
	public boolean simulationFinished = false;
	public int displayFrequency;
	public static Grid2d world;
	public Schedule displaySchedule;
	public ActionGroup displayActions;
	public GroupModelSwarm groupModelSwarm;
	public Leader leader1;
	public Colormap colormap;
	public ZoomRaster worldRaster;
	public EZGraph ezGraph;
	public EZGraph clGraph;
	public EZDistribution Dist;
	public List LeaderList;
	public Object2dDisplay followerDisplay;
	public Object2dDisplay leaderDisplay;
	public int simulatedTime=0;
	public int zoomFactor=8;
	public Selector sel;
	public GroupObserver(Zone aZone) 
	{
		super(aZone);
		displayFrequency = 1;
		class GroupObserverProbeMap extends EmptyProbeMapImpl 
		{
			private VarProbe probeVariable (String name) 
			{
				return
					Globals.env.probeLibrary.getProbeForVariable$inClass(name, GroupObserver.this.getClass ());
			}
			private MessageProbe probeMessage (String name) 
			{
				return
					Globals.env.probeLibrary.getProbeForMessage$inClass
					(name, GroupObserver.this.getClass ());
			}
			private void addVar (String name) 
			{
				addProbe (probeVariable (name));
			}
			private void addMessage (String name) 
			{
				addProbe (probeMessage (name));
			}
			public GroupObserverProbeMap (Zone _aZone, Class aClass) 
			{
				super (_aZone, aClass);
				addVar ("displayFrequency");
				addMessage("zoomFactor");
				addMessage("simulatedTime");
			}
		}
		Globals.env.probeLibrary.setProbeMap$For(new GroupObserverProbeMap (aZone, getClass ()), getClass ());
	}
	public Object _worldRasterDeath_ (Object caller) 
	{
		worldRaster.drop ();
		worldRaster = null;
		return this;
	}
	public Object _ezGraphDeath_(Object caller){
		ezGraph.drop();
		ezGraph = null;
		return this;
	}
	public Object _clGraphDeath_(Object caller){
		clGraph.drop();
		clGraph = null;
		return this;
	}
	public Object buildObjects () 
	{
		super.buildObjects ();
		groupModelSwarm = new GroupModelSwarm (getZone ());
		Globals.env.createArchivedProbeDisplay (groupModelSwarm,"groupModelSwarm");
		Globals.env.createArchivedProbeDisplay (this, "groupObserver");
		getControlPanel ().setStateStopped ();
		if(simulatedTime!=0)
		{
		System.out.println("The user is not allowed to change the simulated time\n");
		}	
		groupModelSwarm.buildObjects ();
		colormap = new ColormapImpl (getZone ());
		colormap.setColor$ToName ((byte) 63, "blue");
		colormap.setColor$ToName ((byte) 64, "green");
		colormap.setColor$ToName ((byte) 65, "red");
		colormap.setColor$ToName ((byte) 66, "yellow");
		List leader = groupModelSwarm.getLeaderList();
		worldRaster = new ZoomRasterImpl (getZone (), "worldRaster");
		sel = SwarmUtils.getSelector(this, "_worldRasterDeath_");
		try 
		{
			worldRaster.enableDestroyNotification$notificationMethod
				(this,
				new Selector (getClass (), "_worldRasterDeath_", false));
		} 
		catch (Exception e) 
		{
			System.err.println ("Exception _worldRasterDeath_: "+ e.getMessage ());
		}
		worldRaster.erase();
		worldRaster.setColormap (colormap);
		worldRaster.setZoomFactor (4);
		worldRaster.setWidth$Height((groupModelSwarm.getWorld ()).getSizeX (),(groupModelSwarm.getWorld ()).getSizeY ());
		worldRaster.setWindowTitle ("Simulation of WorkGroups Using Swarm");
		worldRaster.pack();
		System.out.println("after pack");
		try 
		{
			System.out.println("changing color");
			sel = SwarmUtils.getSelector("Leader","drawSelfOn");
			leaderDisplay = new Object2dDisplayImpl
				(getZone (), worldRaster, groupModelSwarm.getWorld (),sel);
			leaderDisplay.setObjectCollection(groupModelSwarm.getLeader1List());
			sel=SwarmUtils.getSelector(leaderDisplay,"makeProbeAtX$Y");
			worldRaster.setButton$Client$Message(3,leaderDisplay,sel);
			System.out.println("sucessfully changed color");
		}
		catch (Exception e) 
		{
			System.err.println ("Exception drawSelfOn: " + e.getMessage ());
		}
		/*  try {
		System.out.println("I am trying to change leader color");
      leaderDisplay = new Object2dDisplayImpl
        (getZone (), worldRaster, groupModelSwarm.getWorld (),
          new Selector (Class.forName ("Leader"), "drawSelfOn", false));
    }catch (Exception e) {
      System.err.println ("Exception drawSelfOn: " + e.getMessage ());
    }*/
		leaderDisplay.setObjectCollection(groupModelSwarm.getLeader1List ());
		try 
		{
			worldRaster.setButton$Client$Message
				(3, leaderDisplay, new Selector (leaderDisplay.getClass (),
				"makeProbeAtX$Y", true));
		} 
		catch (Exception e) 
		{
			System.err.println ("Exception makeProbeAtX$Y: "+ e.getMessage ());
		}
		ezGraph = new EZGraphImpl(getZone (),"Time and Growth in Group","time", "value","ezGraph");
		try 
		{
			System.out.println("Plotting Graph");
			ezGraph.enableDestroyNotification$notificationMethod
				(this, new Selector (getClass (),"_ezGraphDeath_",false));
		} 
		catch (Exception e) 
		{
			System.err.println ("Exception _ezGraphDeath_: "
				+ e.getMessage ());
		}
		try 
		{
			System.out.println("created a sequence");
			ezGraph.createTotalSequence$withFeedFrom$andSelector
				("value", groupModelSwarm.getLeaderList(),
				new Selector (Class.forName ("MyMathsClass"), "addEmUp",false));
		} 
		catch (Exception e) 
		{
			System.err.println ("Exception inEZGraph: "
				+ e.getMessage ());
		}
		 
			return this;
	}	
		
	public Object _update_ ()  
	{
		System.out.println("I am from update");
		//worldRaster.erase();
		if (worldRaster != null) 
		{
			//worldRaster.erase();
			System.out.println("changing leader display");
			leaderDisplay.display ();
		
			worldRaster.drawSelf();
		}
		if (ezGraph != null)
		{
			ezGraph.step ();
			System.out.println("created step");
			//clGraph.step();
		}
		if(clGraph!=null)
		{
			clGraph.step();
		}
		return this;
	}
	public Object buildActions () 
	{
		super.buildActions();
		groupModelSwarm.buildActions();
		displayActions = new ActionGroupImpl (getZone());


try {
      displayActions.createActionTo$message
        (this, new Selector (getClass (), "_update_", false));

      displayActions.createActionTo$message
        (Globals.env.probeDisplayManager,
         new Selector (Globals.env.probeDisplayManager.getClass (),
                       "update", true));
     
      displayActions.createActionTo$message
        (getActionCache (), new Selector
          (getActionCache ().getClass (), "doTkEvents", true));
    } catch (Exception e) {
      System.err.println ("Exception in setting up displayActions : "
                          + e.getMessage ());
    }
 
	sel = SwarmUtils.getSelector(worldRaster, "drawSelf");
	displayActions.createActionTo$message(worldRaster, sel);

	sel = SwarmUtils.getSelector(this, "updateSimulatedTime");
	displayActions.createActionTo$message(this, sel);

	sel = SwarmUtils.getSelector(Globals.env.probeDisplayManager,
				     "update");
	displayActions.createActionTo$message(Globals.env.probeDisplayManager,
					      sel);

	sel = SwarmUtils.getSelector(getActionCache(), "doTkEvents");
	displayActions.createActionTo$message(getActionCache(), sel);

	sel = SwarmUtils.getSelector(this, "checkForDone");
	displayActions.createActionTo$message(this, sel);

		displaySchedule = new ScheduleImpl (getZone (), displayFrequency);
		displaySchedule.at$createAction(0,displayActions);
		return this;
	}
	public Activity activateIn (Swarm swarmContext) 
	{
		super.activateIn (swarmContext);
		groupModelSwarm.activateIn (this);
		displaySchedule.activateIn (this);
		return getActivity();
	}
	public void checkForDone()
    {
	if (simulationFinished)
	    {
	     System.out.println("I said to QUIT!");
	    groupModelSwarm.getActivity().terminate();
	    groupModelSwarm.drop();
	    getControlPanel().setStateQuit();
	    }
	else if (groupModelSwarm.getActivity().getStatus() ==
		 Globals.env.Completed)
	    {
	     simulationFinished = true;
	    System.out.println("The simulation ended after "
			       + Globals.env.getCurrentTime()
			       + " periods.");
	    System.out.println("Press QUIT when ready.");
	    getControlPanel().setStateStopped();
	    }
    }
	public Object ezGraphAdoption(GroupModelSwarm g)
	{
		if(ezGraph!=null)
			try
			{
				
ezGraph.createAverageSequence$withFeedFrom$andSelector("MyMathsClass",g.getLeaderList(),new Selector(Class.forName("MyMathsClass"),"addEmUp",false));
			}
			catch(Exception e)
			{
				System.out.println("Exception graph average adoption:"+e.getMessage());
			}
		return this;

	}
	public Object clGraphAdoption(GroupModelSwarm g){
	if(clGraph!=null)
	try{
	
clGraph.createAverageSequence$withFeedFrom$andSelector("Leader",g.getLeaderList(),new 
Selector(Class.forName("Leader"),"getvalue",false));
		}
	catch(Exception e)
	{
	System.out.println("Exception in setting up displayActions:"+e.getMessage());
	}
	return this;
	}
	
	public void drop()
	{
		if(ezGraph!=null)
			ezGraph.disableDestroyNotification();
		if (worldRaster != null)
			worldRaster.disableDestroyNotification ();
		if(clGraph!=null)
			clGraph.disableDestroyNotification();
		super.drop ();
	}
	public void updateSimulatedTime()
    {
	simulatedTime = Globals.env.getCurrentTime();
    }
}

